/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * LoongArch Disassembler                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 26, 6,  // Inst{31-26} ...
/* 3 */       MCD::OPC_FilterValue, 0, 29, 8, 0, // Skip to: 2085
/* 8 */       MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 11 */      MCD::OPC_FilterValue, 0, 7, 4, 0, // Skip to: 1047
/* 16 */      MCD::OPC_ExtractField, 18, 4,  // Inst{21-18} ...
/* 19 */      MCD::OPC_FilterValue, 0, 73, 1, 0, // Skip to: 353
/* 24 */      MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 27 */      MCD::OPC_FilterValue, 0, 23, 1, 0, // Skip to: 311
/* 32 */      MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 35 */      MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 44
/* 40 */      MCD::OPC_Decode, 255, 2, 0, // Opcode: CLO_W
/* 44 */      MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 53
/* 49 */      MCD::OPC_Decode, 129, 3, 0, // Opcode: CLZ_W
/* 53 */      MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 62
/* 58 */      MCD::OPC_Decode, 143, 3, 0, // Opcode: CTO_W
/* 62 */      MCD::OPC_FilterValue, 7, 4, 0, 0, // Skip to: 71
/* 67 */      MCD::OPC_Decode, 145, 3, 0, // Opcode: CTZ_W
/* 71 */      MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 85
/* 76 */      MCD::OPC_CheckPredicate, 0, 181, 18, 0, // Skip to: 4870
/* 81 */      MCD::OPC_Decode, 254, 2, 0, // Opcode: CLO_D
/* 85 */      MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 99
/* 90 */      MCD::OPC_CheckPredicate, 0, 167, 18, 0, // Skip to: 4870
/* 95 */      MCD::OPC_Decode, 128, 3, 0, // Opcode: CLZ_D
/* 99 */      MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 113
/* 104 */     MCD::OPC_CheckPredicate, 0, 153, 18, 0, // Skip to: 4870
/* 109 */     MCD::OPC_Decode, 142, 3, 0, // Opcode: CTO_D
/* 113 */     MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 127
/* 118 */     MCD::OPC_CheckPredicate, 0, 139, 18, 0, // Skip to: 4870
/* 123 */     MCD::OPC_Decode, 144, 3, 0, // Opcode: CTZ_D
/* 127 */     MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 136
/* 132 */     MCD::OPC_Decode, 245, 4, 0, // Opcode: REVB_2H
/* 136 */     MCD::OPC_FilterValue, 13, 9, 0, 0, // Skip to: 150
/* 141 */     MCD::OPC_CheckPredicate, 0, 116, 18, 0, // Skip to: 4870
/* 146 */     MCD::OPC_Decode, 247, 4, 0, // Opcode: REVB_4H
/* 150 */     MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 164
/* 155 */     MCD::OPC_CheckPredicate, 0, 102, 18, 0, // Skip to: 4870
/* 160 */     MCD::OPC_Decode, 246, 4, 0, // Opcode: REVB_2W
/* 164 */     MCD::OPC_FilterValue, 15, 9, 0, 0, // Skip to: 178
/* 169 */     MCD::OPC_CheckPredicate, 0, 88, 18, 0, // Skip to: 4870
/* 174 */     MCD::OPC_Decode, 248, 4, 0, // Opcode: REVB_D
/* 178 */     MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 192
/* 183 */     MCD::OPC_CheckPredicate, 0, 74, 18, 0, // Skip to: 4870
/* 188 */     MCD::OPC_Decode, 249, 4, 0, // Opcode: REVH_2W
/* 192 */     MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 206
/* 197 */     MCD::OPC_CheckPredicate, 0, 60, 18, 0, // Skip to: 4870
/* 202 */     MCD::OPC_Decode, 250, 4, 0, // Opcode: REVH_D
/* 206 */     MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 215
/* 211 */     MCD::OPC_Decode, 237, 2, 0, // Opcode: BITREV_4B
/* 215 */     MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 229
/* 220 */     MCD::OPC_CheckPredicate, 0, 37, 18, 0, // Skip to: 4870
/* 225 */     MCD::OPC_Decode, 238, 2, 0, // Opcode: BITREV_8B
/* 229 */     MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 238
/* 234 */     MCD::OPC_Decode, 240, 2, 0, // Opcode: BITREV_W
/* 238 */     MCD::OPC_FilterValue, 21, 9, 0, 0, // Skip to: 252
/* 243 */     MCD::OPC_CheckPredicate, 0, 14, 18, 0, // Skip to: 4870
/* 248 */     MCD::OPC_Decode, 239, 2, 0, // Opcode: BITREV_D
/* 252 */     MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 261
/* 257 */     MCD::OPC_Decode, 154, 3, 0, // Opcode: EXT_W_H
/* 261 */     MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 270
/* 266 */     MCD::OPC_Decode, 153, 3, 0, // Opcode: EXT_W_B
/* 270 */     MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 243, 4, 0, // Opcode: RDTIMEL_W
/* 279 */     MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 288
/* 284 */     MCD::OPC_Decode, 242, 4, 0, // Opcode: RDTIMEH_W
/* 288 */     MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 302
/* 293 */     MCD::OPC_CheckPredicate, 0, 220, 17, 0, // Skip to: 4870
/* 298 */     MCD::OPC_Decode, 244, 4, 0, // Opcode: RDTIME_D
/* 302 */     MCD::OPC_FilterValue, 27, 211, 17, 0, // Skip to: 4870
/* 307 */     MCD::OPC_Decode, 130, 3, 0, // Opcode: CPUCFG
/* 311 */     MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 332
/* 316 */     MCD::OPC_CheckPredicate, 0, 197, 17, 0, // Skip to: 4870
/* 321 */     MCD::OPC_CheckField, 0, 5, 0, 190, 17, 0, // Skip to: 4870
/* 328 */     MCD::OPC_Decode, 229, 2, 1, // Opcode: ASRTLE_D
/* 332 */     MCD::OPC_FilterValue, 3, 181, 17, 0, // Skip to: 4870
/* 337 */     MCD::OPC_CheckPredicate, 0, 176, 17, 0, // Skip to: 4870
/* 342 */     MCD::OPC_CheckField, 0, 5, 0, 169, 17, 0, // Skip to: 4870
/* 349 */     MCD::OPC_Decode, 228, 2, 1, // Opcode: ASRTGT_D
/* 353 */     MCD::OPC_FilterValue, 1, 26, 0, 0, // Skip to: 384
/* 358 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 361 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 370
/* 366 */     MCD::OPC_Decode, 187, 2, 2, // Opcode: ALSL_W
/* 370 */     MCD::OPC_FilterValue, 1, 143, 17, 0, // Skip to: 4870
/* 375 */     MCD::OPC_CheckPredicate, 0, 138, 17, 0, // Skip to: 4870
/* 380 */     MCD::OPC_Decode, 188, 2, 2, // Opcode: ALSL_WU
/* 384 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 400
/* 389 */     MCD::OPC_CheckField, 17, 1, 0, 122, 17, 0, // Skip to: 4870
/* 396 */     MCD::OPC_Decode, 252, 2, 3, // Opcode: BYTEPICK_W
/* 400 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 414
/* 405 */     MCD::OPC_CheckPredicate, 0, 108, 17, 0, // Skip to: 4870
/* 410 */     MCD::OPC_Decode, 251, 2, 4, // Opcode: BYTEPICK_D
/* 414 */     MCD::OPC_FilterValue, 4, 85, 0, 0, // Skip to: 504
/* 419 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 422 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 431
/* 427 */     MCD::OPC_Decode, 185, 2, 5, // Opcode: ADD_W
/* 431 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 445
/* 436 */     MCD::OPC_CheckPredicate, 0, 77, 17, 0, // Skip to: 4870
/* 441 */     MCD::OPC_Decode, 184, 2, 5, // Opcode: ADD_D
/* 445 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 454
/* 450 */     MCD::OPC_Decode, 164, 5, 5, // Opcode: SUB_W
/* 454 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 468
/* 459 */     MCD::OPC_CheckPredicate, 0, 54, 17, 0, // Skip to: 4870
/* 464 */     MCD::OPC_Decode, 163, 5, 5, // Opcode: SUB_D
/* 468 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 477
/* 473 */     MCD::OPC_Decode, 133, 5, 5, // Opcode: SLT
/* 477 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 486
/* 482 */     MCD::OPC_Decode, 135, 5, 5, // Opcode: SLTU
/* 486 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 495
/* 491 */     MCD::OPC_Decode, 204, 4, 5, // Opcode: MASKEQZ
/* 495 */     MCD::OPC_FilterValue, 7, 18, 17, 0, // Skip to: 4870
/* 500 */     MCD::OPC_Decode, 205, 4, 5, // Opcode: MASKNEZ
/* 504 */     MCD::OPC_FilterValue, 5, 75, 0, 0, // Skip to: 584
/* 509 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 512 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 521
/* 517 */     MCD::OPC_Decode, 232, 4, 5, // Opcode: NOR
/* 521 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 530
/* 526 */     MCD::OPC_Decode, 225, 2, 5, // Opcode: AND
/* 530 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 539
/* 535 */     MCD::OPC_Decode, 233, 4, 5, // Opcode: OR
/* 539 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 548
/* 544 */     MCD::OPC_Decode, 172, 5, 5, // Opcode: XOR
/* 548 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 557
/* 553 */     MCD::OPC_Decode, 235, 4, 5, // Opcode: ORN
/* 557 */     MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 566
/* 562 */     MCD::OPC_Decode, 227, 2, 5, // Opcode: ANDN
/* 566 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 575
/* 571 */     MCD::OPC_Decode, 132, 5, 5, // Opcode: SLL_W
/* 575 */     MCD::OPC_FilterValue, 7, 194, 16, 0, // Skip to: 4870
/* 580 */     MCD::OPC_Decode, 144, 5, 5, // Opcode: SRL_W
/* 584 */     MCD::OPC_FilterValue, 6, 77, 0, 0, // Skip to: 666
/* 589 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 592 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 601
/* 597 */     MCD::OPC_Decode, 140, 5, 5, // Opcode: SRA_W
/* 601 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 615
/* 606 */     MCD::OPC_CheckPredicate, 0, 163, 16, 0, // Skip to: 4870
/* 611 */     MCD::OPC_Decode, 131, 5, 5, // Opcode: SLL_D
/* 615 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 629
/* 620 */     MCD::OPC_CheckPredicate, 0, 149, 16, 0, // Skip to: 4870
/* 625 */     MCD::OPC_Decode, 143, 5, 5, // Opcode: SRL_D
/* 629 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 643
/* 634 */     MCD::OPC_CheckPredicate, 0, 135, 16, 0, // Skip to: 4870
/* 639 */     MCD::OPC_Decode, 139, 5, 5, // Opcode: SRA_D
/* 643 */     MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 652
/* 648 */     MCD::OPC_Decode, 254, 4, 5, // Opcode: ROTR_W
/* 652 */     MCD::OPC_FilterValue, 7, 117, 16, 0, // Skip to: 4870
/* 657 */     MCD::OPC_CheckPredicate, 0, 112, 16, 0, // Skip to: 4870
/* 662 */     MCD::OPC_Decode, 253, 4, 5, // Opcode: ROTR_D
/* 666 */     MCD::OPC_FilterValue, 7, 100, 0, 0, // Skip to: 771
/* 671 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 674 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 683
/* 679 */     MCD::OPC_Decode, 231, 4, 5, // Opcode: MUL_W
/* 683 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 692
/* 688 */     MCD::OPC_Decode, 226, 4, 5, // Opcode: MULH_W
/* 692 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 701
/* 697 */     MCD::OPC_Decode, 227, 4, 5, // Opcode: MULH_WU
/* 701 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 715
/* 706 */     MCD::OPC_CheckPredicate, 0, 63, 16, 0, // Skip to: 4870
/* 711 */     MCD::OPC_Decode, 230, 4, 5, // Opcode: MUL_D
/* 715 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 729
/* 720 */     MCD::OPC_CheckPredicate, 0, 49, 16, 0, // Skip to: 4870
/* 725 */     MCD::OPC_Decode, 224, 4, 5, // Opcode: MULH_D
/* 729 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 743
/* 734 */     MCD::OPC_CheckPredicate, 0, 35, 16, 0, // Skip to: 4870
/* 739 */     MCD::OPC_Decode, 225, 4, 5, // Opcode: MULH_DU
/* 743 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 757
/* 748 */     MCD::OPC_CheckPredicate, 0, 21, 16, 0, // Skip to: 4870
/* 753 */     MCD::OPC_Decode, 228, 4, 5, // Opcode: MULW_D_W
/* 757 */     MCD::OPC_FilterValue, 7, 12, 16, 0, // Skip to: 4870
/* 762 */     MCD::OPC_CheckPredicate, 0, 7, 16, 0, // Skip to: 4870
/* 767 */     MCD::OPC_Decode, 229, 4, 5, // Opcode: MULW_D_WU
/* 771 */     MCD::OPC_FilterValue, 8, 95, 0, 0, // Skip to: 871
/* 776 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 779 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 788
/* 784 */     MCD::OPC_Decode, 150, 3, 5, // Opcode: DIV_W
/* 788 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 797
/* 793 */     MCD::OPC_Decode, 208, 4, 5, // Opcode: MOD_W
/* 797 */     MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 806
/* 802 */     MCD::OPC_Decode, 151, 3, 5, // Opcode: DIV_WU
/* 806 */     MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 815
/* 811 */     MCD::OPC_Decode, 209, 4, 5, // Opcode: MOD_WU
/* 815 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 829
/* 820 */     MCD::OPC_CheckPredicate, 0, 205, 15, 0, // Skip to: 4870
/* 825 */     MCD::OPC_Decode, 148, 3, 5, // Opcode: DIV_D
/* 829 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 843
/* 834 */     MCD::OPC_CheckPredicate, 0, 191, 15, 0, // Skip to: 4870
/* 839 */     MCD::OPC_Decode, 206, 4, 5, // Opcode: MOD_D
/* 843 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 857
/* 848 */     MCD::OPC_CheckPredicate, 0, 177, 15, 0, // Skip to: 4870
/* 853 */     MCD::OPC_Decode, 149, 3, 5, // Opcode: DIV_DU
/* 857 */     MCD::OPC_FilterValue, 7, 168, 15, 0, // Skip to: 4870
/* 862 */     MCD::OPC_CheckPredicate, 0, 163, 15, 0, // Skip to: 4870
/* 867 */     MCD::OPC_Decode, 207, 4, 5, // Opcode: MOD_DU
/* 871 */     MCD::OPC_FilterValue, 9, 115, 0, 0, // Skip to: 991
/* 876 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 879 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 893
/* 884 */     MCD::OPC_CheckPredicate, 0, 141, 15, 0, // Skip to: 4870
/* 889 */     MCD::OPC_Decode, 135, 3, 5, // Opcode: CRC_W_B_W
/* 893 */     MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 907
/* 898 */     MCD::OPC_CheckPredicate, 0, 127, 15, 0, // Skip to: 4870
/* 903 */     MCD::OPC_Decode, 137, 3, 5, // Opcode: CRC_W_H_W
/* 907 */     MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 921
/* 912 */     MCD::OPC_CheckPredicate, 0, 113, 15, 0, // Skip to: 4870
/* 917 */     MCD::OPC_Decode, 138, 3, 5, // Opcode: CRC_W_W_W
/* 921 */     MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 935
/* 926 */     MCD::OPC_CheckPredicate, 0, 99, 15, 0, // Skip to: 4870
/* 931 */     MCD::OPC_Decode, 136, 3, 5, // Opcode: CRC_W_D_W
/* 935 */     MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 949
/* 940 */     MCD::OPC_CheckPredicate, 0, 85, 15, 0, // Skip to: 4870
/* 945 */     MCD::OPC_Decode, 131, 3, 5, // Opcode: CRCC_W_B_W
/* 949 */     MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 963
/* 954 */     MCD::OPC_CheckPredicate, 0, 71, 15, 0, // Skip to: 4870
/* 959 */     MCD::OPC_Decode, 133, 3, 5, // Opcode: CRCC_W_H_W
/* 963 */     MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 977
/* 968 */     MCD::OPC_CheckPredicate, 0, 57, 15, 0, // Skip to: 4870
/* 973 */     MCD::OPC_Decode, 134, 3, 5, // Opcode: CRCC_W_W_W
/* 977 */     MCD::OPC_FilterValue, 7, 48, 15, 0, // Skip to: 4870
/* 982 */     MCD::OPC_CheckPredicate, 0, 43, 15, 0, // Skip to: 4870
/* 987 */     MCD::OPC_Decode, 132, 3, 5, // Opcode: CRCC_W_D_W
/* 991 */     MCD::OPC_FilterValue, 10, 30, 0, 0, // Skip to: 1026
/* 996 */     MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 999 */     MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1008
/* 1004 */    MCD::OPC_Decode, 246, 2, 6, // Opcode: BREAK
/* 1008 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1017
/* 1013 */    MCD::OPC_Decode, 147, 3, 6, // Opcode: DBCL
/* 1017 */    MCD::OPC_FilterValue, 6, 8, 15, 0, // Skip to: 4870
/* 1022 */    MCD::OPC_Decode, 165, 5, 6, // Opcode: SYSCALL
/* 1026 */    MCD::OPC_FilterValue, 11, 255, 14, 0, // Skip to: 4870
/* 1031 */    MCD::OPC_CheckPredicate, 0, 250, 14, 0, // Skip to: 4870
/* 1036 */    MCD::OPC_CheckField, 17, 1, 0, 243, 14, 0, // Skip to: 4870
/* 1043 */    MCD::OPC_Decode, 186, 2, 2, // Opcode: ALSL_D
/* 1047 */    MCD::OPC_FilterValue, 1, 157, 0, 0, // Skip to: 1209
/* 1052 */    MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 1055 */    MCD::OPC_FilterValue, 0, 123, 0, 0, // Skip to: 1183
/* 1060 */    MCD::OPC_ExtractField, 16, 5,  // Inst{20-16} ...
/* 1063 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1079
/* 1068 */    MCD::OPC_CheckField, 15, 1, 1, 211, 14, 0, // Skip to: 4870
/* 1075 */    MCD::OPC_Decode, 130, 5, 7, // Opcode: SLLI_W
/* 1079 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 1093
/* 1084 */    MCD::OPC_CheckPredicate, 0, 197, 14, 0, // Skip to: 4870
/* 1089 */    MCD::OPC_Decode, 129, 5, 8, // Opcode: SLLI_D
/* 1093 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 1109
/* 1098 */    MCD::OPC_CheckField, 15, 1, 1, 181, 14, 0, // Skip to: 4870
/* 1105 */    MCD::OPC_Decode, 142, 5, 7, // Opcode: SRLI_W
/* 1109 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 1123
/* 1114 */    MCD::OPC_CheckPredicate, 0, 167, 14, 0, // Skip to: 4870
/* 1119 */    MCD::OPC_Decode, 141, 5, 8, // Opcode: SRLI_D
/* 1123 */    MCD::OPC_FilterValue, 8, 11, 0, 0, // Skip to: 1139
/* 1128 */    MCD::OPC_CheckField, 15, 1, 1, 151, 14, 0, // Skip to: 4870
/* 1135 */    MCD::OPC_Decode, 138, 5, 7, // Opcode: SRAI_W
/* 1139 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 1153
/* 1144 */    MCD::OPC_CheckPredicate, 0, 137, 14, 0, // Skip to: 4870
/* 1149 */    MCD::OPC_Decode, 137, 5, 8, // Opcode: SRAI_D
/* 1153 */    MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 1169
/* 1158 */    MCD::OPC_CheckField, 15, 1, 1, 121, 14, 0, // Skip to: 4870
/* 1165 */    MCD::OPC_Decode, 252, 4, 7, // Opcode: ROTRI_W
/* 1169 */    MCD::OPC_FilterValue, 13, 112, 14, 0, // Skip to: 4870
/* 1174 */    MCD::OPC_CheckPredicate, 0, 107, 14, 0, // Skip to: 4870
/* 1179 */    MCD::OPC_Decode, 251, 4, 8, // Opcode: ROTRI_D
/* 1183 */    MCD::OPC_FilterValue, 1, 98, 14, 0, // Skip to: 4870
/* 1188 */    MCD::OPC_ExtractField, 15, 1,  // Inst{15} ...
/* 1191 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1200
/* 1196 */    MCD::OPC_Decode, 248, 2, 9, // Opcode: BSTRINS_W
/* 1200 */    MCD::OPC_FilterValue, 1, 81, 14, 0, // Skip to: 4870
/* 1205 */    MCD::OPC_Decode, 250, 2, 10, // Opcode: BSTRPICK_W
/* 1209 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 1223
/* 1214 */    MCD::OPC_CheckPredicate, 0, 67, 14, 0, // Skip to: 4870
/* 1219 */    MCD::OPC_Decode, 247, 2, 11, // Opcode: BSTRINS_D
/* 1223 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 1237
/* 1228 */    MCD::OPC_CheckPredicate, 0, 53, 14, 0, // Skip to: 4870
/* 1233 */    MCD::OPC_Decode, 249, 2, 12, // Opcode: BSTRPICK_D
/* 1237 */    MCD::OPC_FilterValue, 4, 249, 2, 0, // Skip to: 2003
/* 1242 */    MCD::OPC_ExtractField, 15, 7,  // Inst{21-15} ...
/* 1245 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1254
/* 1250 */    MCD::OPC_Decode, 158, 3, 13, // Opcode: FADD_S
/* 1254 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1263
/* 1259 */    MCD::OPC_Decode, 157, 3, 14, // Opcode: FADD_D
/* 1263 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1272
/* 1268 */    MCD::OPC_Decode, 140, 4, 13, // Opcode: FSUB_S
/* 1272 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1281
/* 1277 */    MCD::OPC_Decode, 139, 4, 14, // Opcode: FSUB_D
/* 1281 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1290
/* 1286 */    MCD::OPC_Decode, 240, 3, 13, // Opcode: FMUL_S
/* 1290 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1299
/* 1295 */    MCD::OPC_Decode, 239, 3, 14, // Opcode: FMUL_D
/* 1299 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1308
/* 1304 */    MCD::OPC_Decode, 210, 3, 13, // Opcode: FDIV_S
/* 1308 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 1317
/* 1313 */    MCD::OPC_Decode, 209, 3, 14, // Opcode: FDIV_D
/* 1317 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1326
/* 1322 */    MCD::OPC_Decode, 230, 3, 13, // Opcode: FMAX_S
/* 1326 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1335
/* 1331 */    MCD::OPC_Decode, 229, 3, 14, // Opcode: FMAX_D
/* 1335 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1344
/* 1340 */    MCD::OPC_Decode, 234, 3, 13, // Opcode: FMIN_S
/* 1344 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 1353
/* 1349 */    MCD::OPC_Decode, 233, 3, 14, // Opcode: FMIN_D
/* 1353 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1362
/* 1358 */    MCD::OPC_Decode, 228, 3, 13, // Opcode: FMAXA_S
/* 1362 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 1371
/* 1367 */    MCD::OPC_Decode, 227, 3, 14, // Opcode: FMAXA_D
/* 1371 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 1380
/* 1376 */    MCD::OPC_Decode, 232, 3, 13, // Opcode: FMINA_S
/* 1380 */    MCD::OPC_FilterValue, 30, 4, 0, 0, // Skip to: 1389
/* 1385 */    MCD::OPC_Decode, 231, 3, 14, // Opcode: FMINA_D
/* 1389 */    MCD::OPC_FilterValue, 33, 4, 0, 0, // Skip to: 1398
/* 1394 */    MCD::OPC_Decode, 254, 3, 13, // Opcode: FSCALEB_S
/* 1398 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 1407
/* 1403 */    MCD::OPC_Decode, 253, 3, 14, // Opcode: FSCALEB_D
/* 1407 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 1416
/* 1412 */    MCD::OPC_Decode, 206, 3, 13, // Opcode: FCOPYSIGN_S
/* 1416 */    MCD::OPC_FilterValue, 38, 4, 0, 0, // Skip to: 1425
/* 1421 */    MCD::OPC_Decode, 205, 3, 14, // Opcode: FCOPYSIGN_D
/* 1425 */    MCD::OPC_FilterValue, 40, 129, 0, 0, // Skip to: 1559
/* 1430 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1433 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1442
/* 1438 */    MCD::OPC_Decode, 156, 3, 15, // Opcode: FABS_S
/* 1442 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1451
/* 1447 */    MCD::OPC_Decode, 155, 3, 16, // Opcode: FABS_D
/* 1451 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1460
/* 1456 */    MCD::OPC_Decode, 242, 3, 15, // Opcode: FNEG_S
/* 1460 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1469
/* 1465 */    MCD::OPC_Decode, 241, 3, 16, // Opcode: FNEG_D
/* 1469 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1478
/* 1474 */    MCD::OPC_Decode, 224, 3, 15, // Opcode: FLOGB_S
/* 1478 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1487
/* 1483 */    MCD::OPC_Decode, 223, 3, 16, // Opcode: FLOGB_D
/* 1487 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1496
/* 1492 */    MCD::OPC_Decode, 160, 3, 15, // Opcode: FCLASS_S
/* 1496 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 1505
/* 1501 */    MCD::OPC_Decode, 159, 3, 16, // Opcode: FCLASS_D
/* 1505 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1514
/* 1510 */    MCD::OPC_Decode, 130, 4, 15, // Opcode: FSQRT_S
/* 1514 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1523
/* 1519 */    MCD::OPC_Decode, 129, 4, 16, // Opcode: FSQRT_D
/* 1523 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1532
/* 1528 */    MCD::OPC_Decode, 248, 3, 15, // Opcode: FRECIP_S
/* 1532 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 1541
/* 1537 */    MCD::OPC_Decode, 247, 3, 16, // Opcode: FRECIP_D
/* 1541 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1550
/* 1546 */    MCD::OPC_Decode, 252, 3, 15, // Opcode: FRSQRT_S
/* 1550 */    MCD::OPC_FilterValue, 26, 243, 12, 0, // Skip to: 4870
/* 1555 */    MCD::OPC_Decode, 251, 3, 16, // Opcode: FRSQRT_D
/* 1559 */    MCD::OPC_FilterValue, 41, 139, 0, 0, // Skip to: 1703
/* 1564 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1567 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1576
/* 1572 */    MCD::OPC_Decode, 236, 3, 15, // Opcode: FMOV_S
/* 1576 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1585
/* 1581 */    MCD::OPC_Decode, 235, 3, 16, // Opcode: FMOV_D
/* 1585 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1594
/* 1590 */    MCD::OPC_Decode, 222, 4, 17, // Opcode: MOVGR2FR_W
/* 1594 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 1608
/* 1599 */    MCD::OPC_CheckPredicate, 0, 194, 12, 0, // Skip to: 4870
/* 1604 */    MCD::OPC_Decode, 221, 4, 18, // Opcode: MOVGR2FR_D
/* 1608 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 1617
/* 1613 */    MCD::OPC_Decode, 220, 4, 19, // Opcode: MOVGR2FRH_W
/* 1617 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 1626
/* 1622 */    MCD::OPC_Decode, 215, 4, 20, // Opcode: MOVFR2GR_S
/* 1626 */    MCD::OPC_FilterValue, 14, 9, 0, 0, // Skip to: 1640
/* 1631 */    MCD::OPC_CheckPredicate, 0, 162, 12, 0, // Skip to: 4870
/* 1636 */    MCD::OPC_Decode, 214, 4, 21, // Opcode: MOVFR2GR_D
/* 1640 */    MCD::OPC_FilterValue, 15, 4, 0, 0, // Skip to: 1649
/* 1645 */    MCD::OPC_Decode, 217, 4, 21, // Opcode: MOVFRH2GR_S
/* 1649 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1658
/* 1654 */    MCD::OPC_Decode, 219, 4, 22, // Opcode: MOVGR2FCSR
/* 1658 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1667
/* 1663 */    MCD::OPC_Decode, 212, 4, 23, // Opcode: MOVFCSR2GR
/* 1667 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 1676
/* 1672 */    MCD::OPC_Decode, 213, 4, 24, // Opcode: MOVFR2CF_S
/* 1676 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1685
/* 1681 */    MCD::OPC_Decode, 210, 4, 25, // Opcode: MOVCF2FR_S
/* 1685 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 1694
/* 1690 */    MCD::OPC_Decode, 218, 4, 26, // Opcode: MOVGR2CF
/* 1694 */    MCD::OPC_FilterValue, 23, 99, 12, 0, // Skip to: 4870
/* 1699 */    MCD::OPC_Decode, 211, 4, 27, // Opcode: MOVCF2GR
/* 1703 */    MCD::OPC_FilterValue, 50, 21, 0, 0, // Skip to: 1729
/* 1708 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1711 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1720
/* 1716 */    MCD::OPC_Decode, 208, 3, 28, // Opcode: FCVT_S_D
/* 1720 */    MCD::OPC_FilterValue, 9, 73, 12, 0, // Skip to: 4870
/* 1725 */    MCD::OPC_Decode, 207, 3, 29, // Opcode: FCVT_D_S
/* 1729 */    MCD::OPC_FilterValue, 52, 75, 0, 0, // Skip to: 1809
/* 1734 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1737 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1746
/* 1742 */    MCD::OPC_Decode, 144, 4, 15, // Opcode: FTINTRM_W_S
/* 1746 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1755
/* 1751 */    MCD::OPC_Decode, 143, 4, 28, // Opcode: FTINTRM_W_D
/* 1755 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1764
/* 1760 */    MCD::OPC_Decode, 142, 4, 29, // Opcode: FTINTRM_L_S
/* 1764 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1773
/* 1769 */    MCD::OPC_Decode, 141, 4, 16, // Opcode: FTINTRM_L_D
/* 1773 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1782
/* 1778 */    MCD::OPC_Decode, 152, 4, 15, // Opcode: FTINTRP_W_S
/* 1782 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1791
/* 1787 */    MCD::OPC_Decode, 151, 4, 28, // Opcode: FTINTRP_W_D
/* 1791 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1800
/* 1796 */    MCD::OPC_Decode, 150, 4, 29, // Opcode: FTINTRP_L_S
/* 1800 */    MCD::OPC_FilterValue, 26, 249, 11, 0, // Skip to: 4870
/* 1805 */    MCD::OPC_Decode, 149, 4, 16, // Opcode: FTINTRP_L_D
/* 1809 */    MCD::OPC_FilterValue, 53, 75, 0, 0, // Skip to: 1889
/* 1814 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1817 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1826
/* 1822 */    MCD::OPC_Decode, 156, 4, 15, // Opcode: FTINTRZ_W_S
/* 1826 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1835
/* 1831 */    MCD::OPC_Decode, 155, 4, 28, // Opcode: FTINTRZ_W_D
/* 1835 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1844
/* 1840 */    MCD::OPC_Decode, 154, 4, 29, // Opcode: FTINTRZ_L_S
/* 1844 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 1853
/* 1849 */    MCD::OPC_Decode, 153, 4, 16, // Opcode: FTINTRZ_L_D
/* 1853 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1862
/* 1858 */    MCD::OPC_Decode, 148, 4, 15, // Opcode: FTINTRNE_W_S
/* 1862 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1871
/* 1867 */    MCD::OPC_Decode, 147, 4, 28, // Opcode: FTINTRNE_W_D
/* 1871 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 1880
/* 1876 */    MCD::OPC_Decode, 146, 4, 29, // Opcode: FTINTRNE_L_S
/* 1880 */    MCD::OPC_FilterValue, 26, 169, 11, 0, // Skip to: 4870
/* 1885 */    MCD::OPC_Decode, 145, 4, 16, // Opcode: FTINTRNE_L_D
/* 1889 */    MCD::OPC_FilterValue, 54, 39, 0, 0, // Skip to: 1933
/* 1894 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1897 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1906
/* 1902 */    MCD::OPC_Decode, 160, 4, 15, // Opcode: FTINT_W_S
/* 1906 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1915
/* 1911 */    MCD::OPC_Decode, 159, 4, 28, // Opcode: FTINT_W_D
/* 1915 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 1924
/* 1920 */    MCD::OPC_Decode, 158, 4, 29, // Opcode: FTINT_L_S
/* 1924 */    MCD::OPC_FilterValue, 10, 125, 11, 0, // Skip to: 4870
/* 1929 */    MCD::OPC_Decode, 157, 4, 16, // Opcode: FTINT_L_D
/* 1933 */    MCD::OPC_FilterValue, 58, 39, 0, 0, // Skip to: 1977
/* 1938 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1941 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1950
/* 1946 */    MCD::OPC_Decode, 214, 3, 15, // Opcode: FFINT_S_W
/* 1950 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 1959
/* 1955 */    MCD::OPC_Decode, 213, 3, 28, // Opcode: FFINT_S_L
/* 1959 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 1968
/* 1964 */    MCD::OPC_Decode, 212, 3, 29, // Opcode: FFINT_D_W
/* 1968 */    MCD::OPC_FilterValue, 10, 81, 11, 0, // Skip to: 4870
/* 1973 */    MCD::OPC_Decode, 211, 3, 16, // Opcode: FFINT_D_L
/* 1977 */    MCD::OPC_FilterValue, 60, 72, 11, 0, // Skip to: 4870
/* 1982 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 1985 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 1994
/* 1990 */    MCD::OPC_Decode, 250, 3, 15, // Opcode: FRINT_S
/* 1994 */    MCD::OPC_FilterValue, 18, 55, 11, 0, // Skip to: 4870
/* 1999 */    MCD::OPC_Decode, 249, 3, 16, // Opcode: FRINT_D
/* 2003 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 2012
/* 2008 */    MCD::OPC_Decode, 134, 5, 30, // Opcode: SLTI
/* 2012 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 2021
/* 2017 */    MCD::OPC_Decode, 136, 5, 30, // Opcode: SLTUI
/* 2021 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 2030
/* 2026 */    MCD::OPC_Decode, 182, 2, 30, // Opcode: ADDI_W
/* 2030 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 2044
/* 2035 */    MCD::OPC_CheckPredicate, 0, 14, 11, 0, // Skip to: 4870
/* 2040 */    MCD::OPC_Decode, 181, 2, 30, // Opcode: ADDI_D
/* 2044 */    MCD::OPC_FilterValue, 12, 9, 0, 0, // Skip to: 2058
/* 2049 */    MCD::OPC_CheckPredicate, 0, 0, 11, 0, // Skip to: 4870
/* 2054 */    MCD::OPC_Decode, 203, 4, 30, // Opcode: LU52I_D
/* 2058 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 2067
/* 2063 */    MCD::OPC_Decode, 226, 2, 31, // Opcode: ANDI
/* 2067 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 2076
/* 2072 */    MCD::OPC_Decode, 234, 4, 31, // Opcode: ORI
/* 2076 */    MCD::OPC_FilterValue, 15, 229, 10, 0, // Skip to: 4870
/* 2081 */    MCD::OPC_Decode, 173, 5, 31, // Opcode: XORI
/* 2085 */    MCD::OPC_FilterValue, 1, 55, 1, 0, // Skip to: 2401
/* 2090 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 2093 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2123
/* 2098 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 2101 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2110
/* 2106 */    MCD::OPC_Decode, 139, 3, 32, // Opcode: CSRRD
/* 2110 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2119
/* 2115 */    MCD::OPC_Decode, 140, 3, 33, // Opcode: CSRWR
/* 2119 */    MCD::OPC_Decode, 141, 3, 34, // Opcode: CSRXCHG
/* 2123 */    MCD::OPC_FilterValue, 2, 182, 10, 0, // Skip to: 4870
/* 2128 */    MCD::OPC_ExtractField, 22, 2,  // Inst{23-22} ...
/* 2131 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2140
/* 2136 */    MCD::OPC_Decode, 253, 2, 35, // Opcode: CACOP
/* 2140 */    MCD::OPC_FilterValue, 1, 165, 10, 0, // Skip to: 4870
/* 2145 */    MCD::OPC_ExtractField, 18, 4,  // Inst{21-18} ...
/* 2148 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2157
/* 2153 */    MCD::OPC_Decode, 173, 4, 36, // Opcode: LDDIR
/* 2157 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2173
/* 2162 */    MCD::OPC_CheckField, 0, 5, 0, 141, 10, 0, // Skip to: 4870
/* 2169 */    MCD::OPC_Decode, 182, 4, 37, // Opcode: LDPTE
/* 2173 */    MCD::OPC_FilterValue, 2, 132, 10, 0, // Skip to: 4870
/* 2178 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2181 */    MCD::OPC_FilterValue, 0, 197, 0, 0, // Skip to: 2383
/* 2186 */    MCD::OPC_ExtractField, 10, 5,  // Inst{14-10} ...
/* 2189 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2198
/* 2194 */    MCD::OPC_Decode, 164, 4, 0, // Opcode: IOCSRRD_B
/* 2198 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2207
/* 2203 */    MCD::OPC_Decode, 166, 4, 0, // Opcode: IOCSRRD_H
/* 2207 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2216
/* 2212 */    MCD::OPC_Decode, 167, 4, 0, // Opcode: IOCSRRD_W
/* 2216 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 2230
/* 2221 */    MCD::OPC_CheckPredicate, 0, 84, 10, 0, // Skip to: 4870
/* 2226 */    MCD::OPC_Decode, 165, 4, 0, // Opcode: IOCSRRD_D
/* 2230 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2239
/* 2235 */    MCD::OPC_Decode, 168, 4, 0, // Opcode: IOCSRWR_B
/* 2239 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2248
/* 2244 */    MCD::OPC_Decode, 170, 4, 0, // Opcode: IOCSRWR_H
/* 2248 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 2257
/* 2253 */    MCD::OPC_Decode, 171, 4, 0, // Opcode: IOCSRWR_W
/* 2257 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 2271
/* 2262 */    MCD::OPC_CheckPredicate, 0, 43, 10, 0, // Skip to: 4870
/* 2267 */    MCD::OPC_Decode, 169, 4, 0, // Opcode: IOCSRWR_D
/* 2271 */    MCD::OPC_FilterValue, 8, 11, 0, 0, // Skip to: 2287
/* 2276 */    MCD::OPC_CheckField, 0, 10, 0, 27, 10, 0, // Skip to: 4870
/* 2283 */    MCD::OPC_Decode, 166, 5, 38, // Opcode: TLBCLR
/* 2287 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2303
/* 2292 */    MCD::OPC_CheckField, 0, 10, 0, 11, 10, 0, // Skip to: 4870
/* 2299 */    MCD::OPC_Decode, 168, 5, 38, // Opcode: TLBFLUSH
/* 2303 */    MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 2319
/* 2308 */    MCD::OPC_CheckField, 0, 10, 0, 251, 9, 0, // Skip to: 4870
/* 2315 */    MCD::OPC_Decode, 170, 5, 38, // Opcode: TLBSRCH
/* 2319 */    MCD::OPC_FilterValue, 11, 11, 0, 0, // Skip to: 2335
/* 2324 */    MCD::OPC_CheckField, 0, 10, 0, 235, 9, 0, // Skip to: 4870
/* 2331 */    MCD::OPC_Decode, 169, 5, 38, // Opcode: TLBRD
/* 2335 */    MCD::OPC_FilterValue, 12, 11, 0, 0, // Skip to: 2351
/* 2340 */    MCD::OPC_CheckField, 0, 10, 0, 219, 9, 0, // Skip to: 4870
/* 2347 */    MCD::OPC_Decode, 171, 5, 38, // Opcode: TLBWR
/* 2351 */    MCD::OPC_FilterValue, 13, 11, 0, 0, // Skip to: 2367
/* 2356 */    MCD::OPC_CheckField, 0, 10, 0, 203, 9, 0, // Skip to: 4870
/* 2363 */    MCD::OPC_Decode, 167, 5, 38, // Opcode: TLBFILL
/* 2367 */    MCD::OPC_FilterValue, 14, 194, 9, 0, // Skip to: 4870
/* 2372 */    MCD::OPC_CheckField, 0, 10, 0, 187, 9, 0, // Skip to: 4870
/* 2379 */    MCD::OPC_Decode, 152, 3, 38, // Opcode: ERTN
/* 2383 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2392
/* 2388 */    MCD::OPC_Decode, 162, 4, 6, // Opcode: IDLE
/* 2392 */    MCD::OPC_FilterValue, 3, 169, 9, 0, // Skip to: 4870
/* 2397 */    MCD::OPC_Decode, 163, 4, 39, // Opcode: INVTLB
/* 2401 */    MCD::OPC_FilterValue, 2, 75, 0, 0, // Skip to: 2481
/* 2406 */    MCD::OPC_ExtractField, 20, 6,  // Inst{25-20} ...
/* 2409 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2418
/* 2414 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: FMADD_S
/* 2418 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2427
/* 2423 */    MCD::OPC_Decode, 225, 3, 41, // Opcode: FMADD_D
/* 2427 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2436
/* 2432 */    MCD::OPC_Decode, 238, 3, 40, // Opcode: FMSUB_S
/* 2436 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 2445
/* 2441 */    MCD::OPC_Decode, 237, 3, 41, // Opcode: FMSUB_D
/* 2445 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 2454
/* 2450 */    MCD::OPC_Decode, 244, 3, 40, // Opcode: FNMADD_S
/* 2454 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 2463
/* 2459 */    MCD::OPC_Decode, 243, 3, 41, // Opcode: FNMADD_D
/* 2463 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 2472
/* 2468 */    MCD::OPC_Decode, 246, 3, 40, // Opcode: FNMSUB_S
/* 2472 */    MCD::OPC_FilterValue, 14, 89, 9, 0, // Skip to: 4870
/* 2477 */    MCD::OPC_Decode, 245, 3, 41, // Opcode: FNMSUB_D
/* 2481 */    MCD::OPC_FilterValue, 3, 12, 3, 0, // Skip to: 3266
/* 2486 */    MCD::OPC_ExtractField, 18, 8,  // Inst{25-18} ...
/* 2489 */    MCD::OPC_FilterValue, 4, 131, 0, 0, // Skip to: 2625
/* 2494 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2497 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2513
/* 2502 */    MCD::OPC_CheckField, 3, 2, 0, 57, 9, 0, // Skip to: 4870
/* 2509 */    MCD::OPC_Decode, 162, 3, 42, // Opcode: FCMP_CAF_S
/* 2513 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2529
/* 2518 */    MCD::OPC_CheckField, 3, 2, 0, 41, 9, 0, // Skip to: 4870
/* 2525 */    MCD::OPC_Decode, 184, 3, 42, // Opcode: FCMP_SAF_S
/* 2529 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2545
/* 2534 */    MCD::OPC_CheckField, 3, 2, 0, 25, 9, 0, // Skip to: 4870
/* 2541 */    MCD::OPC_Decode, 168, 3, 42, // Opcode: FCMP_CLT_S
/* 2545 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2561
/* 2550 */    MCD::OPC_CheckField, 3, 2, 0, 9, 9, 0, // Skip to: 4870
/* 2557 */    MCD::OPC_Decode, 190, 3, 42, // Opcode: FCMP_SLT_S
/* 2561 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2577
/* 2566 */    MCD::OPC_CheckField, 3, 2, 0, 249, 8, 0, // Skip to: 4870
/* 2573 */    MCD::OPC_Decode, 164, 3, 42, // Opcode: FCMP_CEQ_S
/* 2577 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2593
/* 2582 */    MCD::OPC_CheckField, 3, 2, 0, 233, 8, 0, // Skip to: 4870
/* 2589 */    MCD::OPC_Decode, 186, 3, 42, // Opcode: FCMP_SEQ_S
/* 2593 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2609
/* 2598 */    MCD::OPC_CheckField, 3, 2, 0, 217, 8, 0, // Skip to: 4870
/* 2605 */    MCD::OPC_Decode, 166, 3, 42, // Opcode: FCMP_CLE_S
/* 2609 */    MCD::OPC_FilterValue, 7, 208, 8, 0, // Skip to: 4870
/* 2614 */    MCD::OPC_CheckField, 3, 2, 0, 201, 8, 0, // Skip to: 4870
/* 2621 */    MCD::OPC_Decode, 188, 3, 42, // Opcode: FCMP_SLE_S
/* 2625 */    MCD::OPC_FilterValue, 5, 131, 0, 0, // Skip to: 2761
/* 2630 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2633 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2649
/* 2638 */    MCD::OPC_CheckField, 3, 2, 0, 177, 8, 0, // Skip to: 4870
/* 2645 */    MCD::OPC_Decode, 182, 3, 42, // Opcode: FCMP_CUN_S
/* 2649 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2665
/* 2654 */    MCD::OPC_CheckField, 3, 2, 0, 161, 8, 0, // Skip to: 4870
/* 2661 */    MCD::OPC_Decode, 204, 3, 42, // Opcode: FCMP_SUN_S
/* 2665 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2681
/* 2670 */    MCD::OPC_CheckField, 3, 2, 0, 145, 8, 0, // Skip to: 4870
/* 2677 */    MCD::OPC_Decode, 178, 3, 42, // Opcode: FCMP_CULT_S
/* 2681 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2697
/* 2686 */    MCD::OPC_CheckField, 3, 2, 0, 129, 8, 0, // Skip to: 4870
/* 2693 */    MCD::OPC_Decode, 200, 3, 42, // Opcode: FCMP_SULT_S
/* 2697 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2713
/* 2702 */    MCD::OPC_CheckField, 3, 2, 0, 113, 8, 0, // Skip to: 4870
/* 2709 */    MCD::OPC_Decode, 174, 3, 42, // Opcode: FCMP_CUEQ_S
/* 2713 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2729
/* 2718 */    MCD::OPC_CheckField, 3, 2, 0, 97, 8, 0, // Skip to: 4870
/* 2725 */    MCD::OPC_Decode, 196, 3, 42, // Opcode: FCMP_SUEQ_S
/* 2729 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2745
/* 2734 */    MCD::OPC_CheckField, 3, 2, 0, 81, 8, 0, // Skip to: 4870
/* 2741 */    MCD::OPC_Decode, 176, 3, 42, // Opcode: FCMP_CULE_S
/* 2745 */    MCD::OPC_FilterValue, 7, 72, 8, 0, // Skip to: 4870
/* 2750 */    MCD::OPC_CheckField, 3, 2, 0, 65, 8, 0, // Skip to: 4870
/* 2757 */    MCD::OPC_Decode, 198, 3, 42, // Opcode: FCMP_SULE_S
/* 2761 */    MCD::OPC_FilterValue, 6, 67, 0, 0, // Skip to: 2833
/* 2766 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2769 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2785
/* 2774 */    MCD::OPC_CheckField, 3, 2, 0, 41, 8, 0, // Skip to: 4870
/* 2781 */    MCD::OPC_Decode, 170, 3, 42, // Opcode: FCMP_CNE_S
/* 2785 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2801
/* 2790 */    MCD::OPC_CheckField, 3, 2, 0, 25, 8, 0, // Skip to: 4870
/* 2797 */    MCD::OPC_Decode, 192, 3, 42, // Opcode: FCMP_SNE_S
/* 2801 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2817
/* 2806 */    MCD::OPC_CheckField, 3, 2, 0, 9, 8, 0, // Skip to: 4870
/* 2813 */    MCD::OPC_Decode, 172, 3, 42, // Opcode: FCMP_COR_S
/* 2817 */    MCD::OPC_FilterValue, 5, 0, 8, 0, // Skip to: 4870
/* 2822 */    MCD::OPC_CheckField, 3, 2, 0, 249, 7, 0, // Skip to: 4870
/* 2829 */    MCD::OPC_Decode, 194, 3, 42, // Opcode: FCMP_SOR_S
/* 2833 */    MCD::OPC_FilterValue, 7, 35, 0, 0, // Skip to: 2873
/* 2838 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2841 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2857
/* 2846 */    MCD::OPC_CheckField, 3, 2, 0, 225, 7, 0, // Skip to: 4870
/* 2853 */    MCD::OPC_Decode, 180, 3, 42, // Opcode: FCMP_CUNE_S
/* 2857 */    MCD::OPC_FilterValue, 1, 216, 7, 0, // Skip to: 4870
/* 2862 */    MCD::OPC_CheckField, 3, 2, 0, 209, 7, 0, // Skip to: 4870
/* 2869 */    MCD::OPC_Decode, 202, 3, 42, // Opcode: FCMP_SUNE_S
/* 2873 */    MCD::OPC_FilterValue, 8, 131, 0, 0, // Skip to: 3009
/* 2878 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 2881 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2897
/* 2886 */    MCD::OPC_CheckField, 3, 2, 0, 185, 7, 0, // Skip to: 4870
/* 2893 */    MCD::OPC_Decode, 161, 3, 43, // Opcode: FCMP_CAF_D
/* 2897 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2913
/* 2902 */    MCD::OPC_CheckField, 3, 2, 0, 169, 7, 0, // Skip to: 4870
/* 2909 */    MCD::OPC_Decode, 183, 3, 43, // Opcode: FCMP_SAF_D
/* 2913 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2929
/* 2918 */    MCD::OPC_CheckField, 3, 2, 0, 153, 7, 0, // Skip to: 4870
/* 2925 */    MCD::OPC_Decode, 167, 3, 43, // Opcode: FCMP_CLT_D
/* 2929 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2945
/* 2934 */    MCD::OPC_CheckField, 3, 2, 0, 137, 7, 0, // Skip to: 4870
/* 2941 */    MCD::OPC_Decode, 189, 3, 43, // Opcode: FCMP_SLT_D
/* 2945 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 2961
/* 2950 */    MCD::OPC_CheckField, 3, 2, 0, 121, 7, 0, // Skip to: 4870
/* 2957 */    MCD::OPC_Decode, 163, 3, 43, // Opcode: FCMP_CEQ_D
/* 2961 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2977
/* 2966 */    MCD::OPC_CheckField, 3, 2, 0, 105, 7, 0, // Skip to: 4870
/* 2973 */    MCD::OPC_Decode, 185, 3, 43, // Opcode: FCMP_SEQ_D
/* 2977 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2993
/* 2982 */    MCD::OPC_CheckField, 3, 2, 0, 89, 7, 0, // Skip to: 4870
/* 2989 */    MCD::OPC_Decode, 165, 3, 43, // Opcode: FCMP_CLE_D
/* 2993 */    MCD::OPC_FilterValue, 7, 80, 7, 0, // Skip to: 4870
/* 2998 */    MCD::OPC_CheckField, 3, 2, 0, 73, 7, 0, // Skip to: 4870
/* 3005 */    MCD::OPC_Decode, 187, 3, 43, // Opcode: FCMP_SLE_D
/* 3009 */    MCD::OPC_FilterValue, 9, 131, 0, 0, // Skip to: 3145
/* 3014 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 3017 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3033
/* 3022 */    MCD::OPC_CheckField, 3, 2, 0, 49, 7, 0, // Skip to: 4870
/* 3029 */    MCD::OPC_Decode, 181, 3, 43, // Opcode: FCMP_CUN_D
/* 3033 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3049
/* 3038 */    MCD::OPC_CheckField, 3, 2, 0, 33, 7, 0, // Skip to: 4870
/* 3045 */    MCD::OPC_Decode, 203, 3, 43, // Opcode: FCMP_SUN_D
/* 3049 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3065
/* 3054 */    MCD::OPC_CheckField, 3, 2, 0, 17, 7, 0, // Skip to: 4870
/* 3061 */    MCD::OPC_Decode, 177, 3, 43, // Opcode: FCMP_CULT_D
/* 3065 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 3081
/* 3070 */    MCD::OPC_CheckField, 3, 2, 0, 1, 7, 0, // Skip to: 4870
/* 3077 */    MCD::OPC_Decode, 199, 3, 43, // Opcode: FCMP_SULT_D
/* 3081 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 3097
/* 3086 */    MCD::OPC_CheckField, 3, 2, 0, 241, 6, 0, // Skip to: 4870
/* 3093 */    MCD::OPC_Decode, 173, 3, 43, // Opcode: FCMP_CUEQ_D
/* 3097 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 3113
/* 3102 */    MCD::OPC_CheckField, 3, 2, 0, 225, 6, 0, // Skip to: 4870
/* 3109 */    MCD::OPC_Decode, 195, 3, 43, // Opcode: FCMP_SUEQ_D
/* 3113 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 3129
/* 3118 */    MCD::OPC_CheckField, 3, 2, 0, 209, 6, 0, // Skip to: 4870
/* 3125 */    MCD::OPC_Decode, 175, 3, 43, // Opcode: FCMP_CULE_D
/* 3129 */    MCD::OPC_FilterValue, 7, 200, 6, 0, // Skip to: 4870
/* 3134 */    MCD::OPC_CheckField, 3, 2, 0, 193, 6, 0, // Skip to: 4870
/* 3141 */    MCD::OPC_Decode, 197, 3, 43, // Opcode: FCMP_SULE_D
/* 3145 */    MCD::OPC_FilterValue, 10, 67, 0, 0, // Skip to: 3217
/* 3150 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 3153 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3169
/* 3158 */    MCD::OPC_CheckField, 3, 2, 0, 169, 6, 0, // Skip to: 4870
/* 3165 */    MCD::OPC_Decode, 169, 3, 43, // Opcode: FCMP_CNE_D
/* 3169 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3185
/* 3174 */    MCD::OPC_CheckField, 3, 2, 0, 153, 6, 0, // Skip to: 4870
/* 3181 */    MCD::OPC_Decode, 191, 3, 43, // Opcode: FCMP_SNE_D
/* 3185 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 3201
/* 3190 */    MCD::OPC_CheckField, 3, 2, 0, 137, 6, 0, // Skip to: 4870
/* 3197 */    MCD::OPC_Decode, 171, 3, 43, // Opcode: FCMP_COR_D
/* 3201 */    MCD::OPC_FilterValue, 5, 128, 6, 0, // Skip to: 4870
/* 3206 */    MCD::OPC_CheckField, 3, 2, 0, 121, 6, 0, // Skip to: 4870
/* 3213 */    MCD::OPC_Decode, 193, 3, 43, // Opcode: FCMP_SOR_D
/* 3217 */    MCD::OPC_FilterValue, 11, 35, 0, 0, // Skip to: 3257
/* 3222 */    MCD::OPC_ExtractField, 15, 3,  // Inst{17-15} ...
/* 3225 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3241
/* 3230 */    MCD::OPC_CheckField, 3, 2, 0, 97, 6, 0, // Skip to: 4870
/* 3237 */    MCD::OPC_Decode, 179, 3, 43, // Opcode: FCMP_CUNE_D
/* 3241 */    MCD::OPC_FilterValue, 1, 88, 6, 0, // Skip to: 4870
/* 3246 */    MCD::OPC_CheckField, 3, 2, 0, 81, 6, 0, // Skip to: 4870
/* 3253 */    MCD::OPC_Decode, 201, 3, 43, // Opcode: FCMP_SUNE_D
/* 3257 */    MCD::OPC_FilterValue, 64, 72, 6, 0, // Skip to: 4870
/* 3262 */    MCD::OPC_Decode, 128, 4, 44, // Opcode: FSEL_S
/* 3266 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 3280
/* 3271 */    MCD::OPC_CheckPredicate, 0, 58, 6, 0, // Skip to: 4870
/* 3276 */    MCD::OPC_Decode, 183, 2, 45, // Opcode: ADDU16I_D
/* 3280 */    MCD::OPC_FilterValue, 5, 26, 0, 0, // Skip to: 3311
/* 3285 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3288 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3297
/* 3293 */    MCD::OPC_Decode, 201, 4, 46, // Opcode: LU12I_W
/* 3297 */    MCD::OPC_FilterValue, 1, 32, 6, 0, // Skip to: 4870
/* 3302 */    MCD::OPC_CheckPredicate, 0, 27, 6, 0, // Skip to: 4870
/* 3307 */    MCD::OPC_Decode, 202, 4, 47, // Opcode: LU32I_D
/* 3311 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 3337
/* 3316 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3319 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3328
/* 3324 */    MCD::OPC_Decode, 236, 4, 46, // Opcode: PCADDI
/* 3328 */    MCD::OPC_FilterValue, 1, 1, 6, 0, // Skip to: 4870
/* 3333 */    MCD::OPC_Decode, 239, 4, 46, // Opcode: PCALAU12I
/* 3337 */    MCD::OPC_FilterValue, 7, 26, 0, 0, // Skip to: 3368
/* 3342 */    MCD::OPC_ExtractField, 25, 1,  // Inst{25} ...
/* 3345 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3354
/* 3350 */    MCD::OPC_Decode, 237, 4, 46, // Opcode: PCADDU12I
/* 3354 */    MCD::OPC_FilterValue, 1, 231, 5, 0, // Skip to: 4870
/* 3359 */    MCD::OPC_CheckPredicate, 0, 226, 5, 0, // Skip to: 4870
/* 3364 */    MCD::OPC_Decode, 238, 4, 46, // Opcode: PCADDU18I
/* 3368 */    MCD::OPC_FilterValue, 8, 49, 0, 0, // Skip to: 3422
/* 3373 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 3376 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3385
/* 3381 */    MCD::OPC_Decode, 200, 4, 48, // Opcode: LL_W
/* 3385 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3394
/* 3390 */    MCD::OPC_Decode, 128, 5, 49, // Opcode: SC_W
/* 3394 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3408
/* 3399 */    MCD::OPC_CheckPredicate, 0, 186, 5, 0, // Skip to: 4870
/* 3404 */    MCD::OPC_Decode, 199, 4, 48, // Opcode: LL_D
/* 3408 */    MCD::OPC_FilterValue, 3, 177, 5, 0, // Skip to: 4870
/* 3413 */    MCD::OPC_CheckPredicate, 0, 172, 5, 0, // Skip to: 4870
/* 3418 */    MCD::OPC_Decode, 255, 4, 49, // Opcode: SC_D
/* 3422 */    MCD::OPC_FilterValue, 9, 59, 0, 0, // Skip to: 3486
/* 3427 */    MCD::OPC_ExtractField, 24, 2,  // Inst{25-24} ...
/* 3430 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3444
/* 3435 */    MCD::OPC_CheckPredicate, 0, 150, 5, 0, // Skip to: 4870
/* 3440 */    MCD::OPC_Decode, 184, 4, 48, // Opcode: LDPTR_W
/* 3444 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3458
/* 3449 */    MCD::OPC_CheckPredicate, 0, 136, 5, 0, // Skip to: 4870
/* 3454 */    MCD::OPC_Decode, 154, 5, 48, // Opcode: STPTR_W
/* 3458 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 3472
/* 3463 */    MCD::OPC_CheckPredicate, 0, 122, 5, 0, // Skip to: 4870
/* 3468 */    MCD::OPC_Decode, 183, 4, 48, // Opcode: LDPTR_D
/* 3472 */    MCD::OPC_FilterValue, 3, 113, 5, 0, // Skip to: 4870
/* 3477 */    MCD::OPC_CheckPredicate, 0, 108, 5, 0, // Skip to: 4870
/* 3482 */    MCD::OPC_Decode, 153, 5, 48, // Opcode: STPTR_D
/* 3486 */    MCD::OPC_FilterValue, 10, 162, 0, 0, // Skip to: 3653
/* 3491 */    MCD::OPC_ExtractField, 22, 4,  // Inst{25-22} ...
/* 3494 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3503
/* 3499 */    MCD::OPC_Decode, 192, 4, 30, // Opcode: LD_B
/* 3503 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3512
/* 3508 */    MCD::OPC_Decode, 195, 4, 30, // Opcode: LD_H
/* 3512 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3521
/* 3517 */    MCD::OPC_Decode, 197, 4, 30, // Opcode: LD_W
/* 3521 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 3535
/* 3526 */    MCD::OPC_CheckPredicate, 0, 59, 5, 0, // Skip to: 4870
/* 3531 */    MCD::OPC_Decode, 194, 4, 30, // Opcode: LD_D
/* 3535 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 3544
/* 3540 */    MCD::OPC_Decode, 159, 5, 30, // Opcode: ST_B
/* 3544 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 3553
/* 3549 */    MCD::OPC_Decode, 161, 5, 30, // Opcode: ST_H
/* 3553 */    MCD::OPC_FilterValue, 6, 4, 0, 0, // Skip to: 3562
/* 3558 */    MCD::OPC_Decode, 162, 5, 30, // Opcode: ST_W
/* 3562 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 3576
/* 3567 */    MCD::OPC_CheckPredicate, 0, 18, 5, 0, // Skip to: 4870
/* 3572 */    MCD::OPC_Decode, 160, 5, 30, // Opcode: ST_D
/* 3576 */    MCD::OPC_FilterValue, 8, 4, 0, 0, // Skip to: 3585
/* 3581 */    MCD::OPC_Decode, 193, 4, 30, // Opcode: LD_BU
/* 3585 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 3594
/* 3590 */    MCD::OPC_Decode, 196, 4, 30, // Opcode: LD_HU
/* 3594 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 3608
/* 3599 */    MCD::OPC_CheckPredicate, 0, 242, 4, 0, // Skip to: 4870
/* 3604 */    MCD::OPC_Decode, 198, 4, 30, // Opcode: LD_WU
/* 3608 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 3617
/* 3613 */    MCD::OPC_Decode, 240, 4, 35, // Opcode: PRELD
/* 3617 */    MCD::OPC_FilterValue, 12, 4, 0, 0, // Skip to: 3626
/* 3622 */    MCD::OPC_Decode, 222, 3, 50, // Opcode: FLD_S
/* 3626 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 3635
/* 3631 */    MCD::OPC_Decode, 138, 4, 50, // Opcode: FST_S
/* 3635 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 3644
/* 3640 */    MCD::OPC_Decode, 221, 3, 51, // Opcode: FLD_D
/* 3644 */    MCD::OPC_FilterValue, 15, 197, 4, 0, // Skip to: 4870
/* 3649 */    MCD::OPC_Decode, 137, 4, 51, // Opcode: FST_D
/* 3653 */    MCD::OPC_FilterValue, 14, 63, 4, 0, // Skip to: 4745
/* 3658 */    MCD::OPC_ExtractField, 15, 11,  // Inst{25-15} ...
/* 3661 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3675
/* 3666 */    MCD::OPC_CheckPredicate, 0, 175, 4, 0, // Skip to: 4870
/* 3671 */    MCD::OPC_Decode, 185, 4, 5, // Opcode: LDX_B
/* 3675 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 3689
/* 3680 */    MCD::OPC_CheckPredicate, 0, 161, 4, 0, // Skip to: 4870
/* 3685 */    MCD::OPC_Decode, 188, 4, 5, // Opcode: LDX_H
/* 3689 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 3703
/* 3694 */    MCD::OPC_CheckPredicate, 0, 147, 4, 0, // Skip to: 4870
/* 3699 */    MCD::OPC_Decode, 190, 4, 5, // Opcode: LDX_W
/* 3703 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 3717
/* 3708 */    MCD::OPC_CheckPredicate, 0, 133, 4, 0, // Skip to: 4870
/* 3713 */    MCD::OPC_Decode, 187, 4, 5, // Opcode: LDX_D
/* 3717 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 3731
/* 3722 */    MCD::OPC_CheckPredicate, 0, 119, 4, 0, // Skip to: 4870
/* 3727 */    MCD::OPC_Decode, 155, 5, 5, // Opcode: STX_B
/* 3731 */    MCD::OPC_FilterValue, 40, 9, 0, 0, // Skip to: 3745
/* 3736 */    MCD::OPC_CheckPredicate, 0, 105, 4, 0, // Skip to: 4870
/* 3741 */    MCD::OPC_Decode, 157, 5, 5, // Opcode: STX_H
/* 3745 */    MCD::OPC_FilterValue, 48, 9, 0, 0, // Skip to: 3759
/* 3750 */    MCD::OPC_CheckPredicate, 0, 91, 4, 0, // Skip to: 4870
/* 3755 */    MCD::OPC_Decode, 158, 5, 5, // Opcode: STX_W
/* 3759 */    MCD::OPC_FilterValue, 56, 9, 0, 0, // Skip to: 3773
/* 3764 */    MCD::OPC_CheckPredicate, 0, 77, 4, 0, // Skip to: 4870
/* 3769 */    MCD::OPC_Decode, 156, 5, 5, // Opcode: STX_D
/* 3773 */    MCD::OPC_FilterValue, 64, 9, 0, 0, // Skip to: 3787
/* 3778 */    MCD::OPC_CheckPredicate, 0, 63, 4, 0, // Skip to: 4870
/* 3783 */    MCD::OPC_Decode, 186, 4, 5, // Opcode: LDX_BU
/* 3787 */    MCD::OPC_FilterValue, 72, 9, 0, 0, // Skip to: 3801
/* 3792 */    MCD::OPC_CheckPredicate, 0, 49, 4, 0, // Skip to: 4870
/* 3797 */    MCD::OPC_Decode, 189, 4, 5, // Opcode: LDX_HU
/* 3801 */    MCD::OPC_FilterValue, 80, 9, 0, 0, // Skip to: 3815
/* 3806 */    MCD::OPC_CheckPredicate, 0, 35, 4, 0, // Skip to: 4870
/* 3811 */    MCD::OPC_Decode, 191, 4, 5, // Opcode: LDX_WU
/* 3815 */    MCD::OPC_FilterValue, 88, 9, 0, 0, // Skip to: 3829
/* 3820 */    MCD::OPC_CheckPredicate, 0, 21, 4, 0, // Skip to: 4870
/* 3825 */    MCD::OPC_Decode, 241, 4, 52, // Opcode: PRELDX
/* 3829 */    MCD::OPC_FilterValue, 96, 4, 0, 0, // Skip to: 3838
/* 3834 */    MCD::OPC_Decode, 220, 3, 53, // Opcode: FLDX_S
/* 3838 */    MCD::OPC_FilterValue, 104, 4, 0, 0, // Skip to: 3847
/* 3843 */    MCD::OPC_Decode, 219, 3, 54, // Opcode: FLDX_D
/* 3847 */    MCD::OPC_FilterValue, 112, 4, 0, 0, // Skip to: 3856
/* 3852 */    MCD::OPC_Decode, 136, 4, 53, // Opcode: FSTX_S
/* 3856 */    MCD::OPC_FilterValue, 120, 4, 0, 0, // Skip to: 3865
/* 3861 */    MCD::OPC_Decode, 135, 4, 54, // Opcode: FSTX_D
/* 3865 */    MCD::OPC_FilterValue, 192, 1, 9, 0, 0, // Skip to: 3880
/* 3871 */    MCD::OPC_CheckPredicate, 0, 226, 3, 0, // Skip to: 4870
/* 3876 */    MCD::OPC_Decode, 220, 2, 55, // Opcode: AMSWAP_W
/* 3880 */    MCD::OPC_FilterValue, 193, 1, 9, 0, 0, // Skip to: 3895
/* 3886 */    MCD::OPC_CheckPredicate, 0, 211, 3, 0, // Skip to: 4870
/* 3891 */    MCD::OPC_Decode, 217, 2, 55, // Opcode: AMSWAP_D
/* 3895 */    MCD::OPC_FilterValue, 194, 1, 9, 0, 0, // Skip to: 3910
/* 3901 */    MCD::OPC_CheckPredicate, 0, 196, 3, 0, // Skip to: 4870
/* 3906 */    MCD::OPC_Decode, 192, 2, 55, // Opcode: AMADD_W
/* 3910 */    MCD::OPC_FilterValue, 195, 1, 9, 0, 0, // Skip to: 3925
/* 3916 */    MCD::OPC_CheckPredicate, 0, 181, 3, 0, // Skip to: 4870
/* 3921 */    MCD::OPC_Decode, 189, 2, 55, // Opcode: AMADD_D
/* 3925 */    MCD::OPC_FilterValue, 196, 1, 9, 0, 0, // Skip to: 3940
/* 3931 */    MCD::OPC_CheckPredicate, 0, 166, 3, 0, // Skip to: 4870
/* 3936 */    MCD::OPC_Decode, 196, 2, 55, // Opcode: AMAND_W
/* 3940 */    MCD::OPC_FilterValue, 197, 1, 9, 0, 0, // Skip to: 3955
/* 3946 */    MCD::OPC_CheckPredicate, 0, 151, 3, 0, // Skip to: 4870
/* 3951 */    MCD::OPC_Decode, 193, 2, 55, // Opcode: AMAND_D
/* 3955 */    MCD::OPC_FilterValue, 198, 1, 9, 0, 0, // Skip to: 3970
/* 3961 */    MCD::OPC_CheckPredicate, 0, 136, 3, 0, // Skip to: 4870
/* 3966 */    MCD::OPC_Decode, 216, 2, 55, // Opcode: AMOR_W
/* 3970 */    MCD::OPC_FilterValue, 199, 1, 9, 0, 0, // Skip to: 3985
/* 3976 */    MCD::OPC_CheckPredicate, 0, 121, 3, 0, // Skip to: 4870
/* 3981 */    MCD::OPC_Decode, 213, 2, 55, // Opcode: AMOR_D
/* 3985 */    MCD::OPC_FilterValue, 200, 1, 9, 0, 0, // Skip to: 4000
/* 3991 */    MCD::OPC_CheckPredicate, 0, 106, 3, 0, // Skip to: 4870
/* 3996 */    MCD::OPC_Decode, 224, 2, 55, // Opcode: AMXOR_W
/* 4000 */    MCD::OPC_FilterValue, 201, 1, 9, 0, 0, // Skip to: 4015
/* 4006 */    MCD::OPC_CheckPredicate, 0, 91, 3, 0, // Skip to: 4870
/* 4011 */    MCD::OPC_Decode, 221, 2, 55, // Opcode: AMXOR_D
/* 4015 */    MCD::OPC_FilterValue, 202, 1, 9, 0, 0, // Skip to: 4030
/* 4021 */    MCD::OPC_CheckPredicate, 0, 76, 3, 0, // Skip to: 4870
/* 4026 */    MCD::OPC_Decode, 203, 2, 55, // Opcode: AMMAX_W
/* 4030 */    MCD::OPC_FilterValue, 203, 1, 9, 0, 0, // Skip to: 4045
/* 4036 */    MCD::OPC_CheckPredicate, 0, 61, 3, 0, // Skip to: 4870
/* 4041 */    MCD::OPC_Decode, 197, 2, 55, // Opcode: AMMAX_D
/* 4045 */    MCD::OPC_FilterValue, 204, 1, 9, 0, 0, // Skip to: 4060
/* 4051 */    MCD::OPC_CheckPredicate, 0, 46, 3, 0, // Skip to: 4870
/* 4056 */    MCD::OPC_Decode, 211, 2, 55, // Opcode: AMMIN_W
/* 4060 */    MCD::OPC_FilterValue, 205, 1, 9, 0, 0, // Skip to: 4075
/* 4066 */    MCD::OPC_CheckPredicate, 0, 31, 3, 0, // Skip to: 4870
/* 4071 */    MCD::OPC_Decode, 205, 2, 55, // Opcode: AMMIN_D
/* 4075 */    MCD::OPC_FilterValue, 206, 1, 9, 0, 0, // Skip to: 4090
/* 4081 */    MCD::OPC_CheckPredicate, 0, 16, 3, 0, // Skip to: 4870
/* 4086 */    MCD::OPC_Decode, 204, 2, 55, // Opcode: AMMAX_WU
/* 4090 */    MCD::OPC_FilterValue, 207, 1, 9, 0, 0, // Skip to: 4105
/* 4096 */    MCD::OPC_CheckPredicate, 0, 1, 3, 0, // Skip to: 4870
/* 4101 */    MCD::OPC_Decode, 202, 2, 55, // Opcode: AMMAX_DU
/* 4105 */    MCD::OPC_FilterValue, 208, 1, 9, 0, 0, // Skip to: 4120
/* 4111 */    MCD::OPC_CheckPredicate, 0, 242, 2, 0, // Skip to: 4870
/* 4116 */    MCD::OPC_Decode, 212, 2, 55, // Opcode: AMMIN_WU
/* 4120 */    MCD::OPC_FilterValue, 209, 1, 9, 0, 0, // Skip to: 4135
/* 4126 */    MCD::OPC_CheckPredicate, 0, 227, 2, 0, // Skip to: 4870
/* 4131 */    MCD::OPC_Decode, 210, 2, 55, // Opcode: AMMIN_DU
/* 4135 */    MCD::OPC_FilterValue, 210, 1, 9, 0, 0, // Skip to: 4150
/* 4141 */    MCD::OPC_CheckPredicate, 0, 212, 2, 0, // Skip to: 4870
/* 4146 */    MCD::OPC_Decode, 219, 2, 55, // Opcode: AMSWAP_DB_W
/* 4150 */    MCD::OPC_FilterValue, 211, 1, 9, 0, 0, // Skip to: 4165
/* 4156 */    MCD::OPC_CheckPredicate, 0, 197, 2, 0, // Skip to: 4870
/* 4161 */    MCD::OPC_Decode, 218, 2, 55, // Opcode: AMSWAP_DB_D
/* 4165 */    MCD::OPC_FilterValue, 212, 1, 9, 0, 0, // Skip to: 4180
/* 4171 */    MCD::OPC_CheckPredicate, 0, 182, 2, 0, // Skip to: 4870
/* 4176 */    MCD::OPC_Decode, 191, 2, 55, // Opcode: AMADD_DB_W
/* 4180 */    MCD::OPC_FilterValue, 213, 1, 9, 0, 0, // Skip to: 4195
/* 4186 */    MCD::OPC_CheckPredicate, 0, 167, 2, 0, // Skip to: 4870
/* 4191 */    MCD::OPC_Decode, 190, 2, 55, // Opcode: AMADD_DB_D
/* 4195 */    MCD::OPC_FilterValue, 214, 1, 9, 0, 0, // Skip to: 4210
/* 4201 */    MCD::OPC_CheckPredicate, 0, 152, 2, 0, // Skip to: 4870
/* 4206 */    MCD::OPC_Decode, 195, 2, 55, // Opcode: AMAND_DB_W
/* 4210 */    MCD::OPC_FilterValue, 215, 1, 9, 0, 0, // Skip to: 4225
/* 4216 */    MCD::OPC_CheckPredicate, 0, 137, 2, 0, // Skip to: 4870
/* 4221 */    MCD::OPC_Decode, 194, 2, 55, // Opcode: AMAND_DB_D
/* 4225 */    MCD::OPC_FilterValue, 216, 1, 9, 0, 0, // Skip to: 4240
/* 4231 */    MCD::OPC_CheckPredicate, 0, 122, 2, 0, // Skip to: 4870
/* 4236 */    MCD::OPC_Decode, 215, 2, 55, // Opcode: AMOR_DB_W
/* 4240 */    MCD::OPC_FilterValue, 217, 1, 9, 0, 0, // Skip to: 4255
/* 4246 */    MCD::OPC_CheckPredicate, 0, 107, 2, 0, // Skip to: 4870
/* 4251 */    MCD::OPC_Decode, 214, 2, 55, // Opcode: AMOR_DB_D
/* 4255 */    MCD::OPC_FilterValue, 218, 1, 9, 0, 0, // Skip to: 4270
/* 4261 */    MCD::OPC_CheckPredicate, 0, 92, 2, 0, // Skip to: 4870
/* 4266 */    MCD::OPC_Decode, 223, 2, 55, // Opcode: AMXOR_DB_W
/* 4270 */    MCD::OPC_FilterValue, 219, 1, 9, 0, 0, // Skip to: 4285
/* 4276 */    MCD::OPC_CheckPredicate, 0, 77, 2, 0, // Skip to: 4870
/* 4281 */    MCD::OPC_Decode, 222, 2, 55, // Opcode: AMXOR_DB_D
/* 4285 */    MCD::OPC_FilterValue, 220, 1, 9, 0, 0, // Skip to: 4300
/* 4291 */    MCD::OPC_CheckPredicate, 0, 62, 2, 0, // Skip to: 4870
/* 4296 */    MCD::OPC_Decode, 200, 2, 55, // Opcode: AMMAX_DB_W
/* 4300 */    MCD::OPC_FilterValue, 221, 1, 9, 0, 0, // Skip to: 4315
/* 4306 */    MCD::OPC_CheckPredicate, 0, 47, 2, 0, // Skip to: 4870
/* 4311 */    MCD::OPC_Decode, 198, 2, 55, // Opcode: AMMAX_DB_D
/* 4315 */    MCD::OPC_FilterValue, 222, 1, 9, 0, 0, // Skip to: 4330
/* 4321 */    MCD::OPC_CheckPredicate, 0, 32, 2, 0, // Skip to: 4870
/* 4326 */    MCD::OPC_Decode, 208, 2, 55, // Opcode: AMMIN_DB_W
/* 4330 */    MCD::OPC_FilterValue, 223, 1, 9, 0, 0, // Skip to: 4345
/* 4336 */    MCD::OPC_CheckPredicate, 0, 17, 2, 0, // Skip to: 4870
/* 4341 */    MCD::OPC_Decode, 206, 2, 55, // Opcode: AMMIN_DB_D
/* 4345 */    MCD::OPC_FilterValue, 224, 1, 9, 0, 0, // Skip to: 4360
/* 4351 */    MCD::OPC_CheckPredicate, 0, 2, 2, 0, // Skip to: 4870
/* 4356 */    MCD::OPC_Decode, 201, 2, 55, // Opcode: AMMAX_DB_WU
/* 4360 */    MCD::OPC_FilterValue, 225, 1, 9, 0, 0, // Skip to: 4375
/* 4366 */    MCD::OPC_CheckPredicate, 0, 243, 1, 0, // Skip to: 4870
/* 4371 */    MCD::OPC_Decode, 199, 2, 55, // Opcode: AMMAX_DB_DU
/* 4375 */    MCD::OPC_FilterValue, 226, 1, 9, 0, 0, // Skip to: 4390
/* 4381 */    MCD::OPC_CheckPredicate, 0, 228, 1, 0, // Skip to: 4870
/* 4386 */    MCD::OPC_Decode, 209, 2, 55, // Opcode: AMMIN_DB_WU
/* 4390 */    MCD::OPC_FilterValue, 227, 1, 9, 0, 0, // Skip to: 4405
/* 4396 */    MCD::OPC_CheckPredicate, 0, 213, 1, 0, // Skip to: 4870
/* 4401 */    MCD::OPC_Decode, 207, 2, 55, // Opcode: AMMIN_DB_DU
/* 4405 */    MCD::OPC_FilterValue, 228, 1, 4, 0, 0, // Skip to: 4415
/* 4411 */    MCD::OPC_Decode, 146, 3, 6, // Opcode: DBAR
/* 4415 */    MCD::OPC_FilterValue, 229, 1, 4, 0, 0, // Skip to: 4425
/* 4421 */    MCD::OPC_Decode, 161, 4, 6, // Opcode: IBAR
/* 4425 */    MCD::OPC_FilterValue, 232, 1, 4, 0, 0, // Skip to: 4435
/* 4431 */    MCD::OPC_Decode, 216, 3, 53, // Opcode: FLDGT_S
/* 4435 */    MCD::OPC_FilterValue, 233, 1, 4, 0, 0, // Skip to: 4445
/* 4441 */    MCD::OPC_Decode, 215, 3, 54, // Opcode: FLDGT_D
/* 4445 */    MCD::OPC_FilterValue, 234, 1, 4, 0, 0, // Skip to: 4455
/* 4451 */    MCD::OPC_Decode, 218, 3, 53, // Opcode: FLDLE_S
/* 4455 */    MCD::OPC_FilterValue, 235, 1, 4, 0, 0, // Skip to: 4465
/* 4461 */    MCD::OPC_Decode, 217, 3, 54, // Opcode: FLDLE_D
/* 4465 */    MCD::OPC_FilterValue, 236, 1, 4, 0, 0, // Skip to: 4475
/* 4471 */    MCD::OPC_Decode, 132, 4, 53, // Opcode: FSTGT_S
/* 4475 */    MCD::OPC_FilterValue, 237, 1, 4, 0, 0, // Skip to: 4485
/* 4481 */    MCD::OPC_Decode, 131, 4, 54, // Opcode: FSTGT_D
/* 4485 */    MCD::OPC_FilterValue, 238, 1, 4, 0, 0, // Skip to: 4495
/* 4491 */    MCD::OPC_Decode, 134, 4, 53, // Opcode: FSTLE_S
/* 4495 */    MCD::OPC_FilterValue, 239, 1, 4, 0, 0, // Skip to: 4505
/* 4501 */    MCD::OPC_Decode, 133, 4, 54, // Opcode: FSTLE_D
/* 4505 */    MCD::OPC_FilterValue, 240, 1, 9, 0, 0, // Skip to: 4520
/* 4511 */    MCD::OPC_CheckPredicate, 0, 98, 1, 0, // Skip to: 4870
/* 4516 */    MCD::OPC_Decode, 174, 4, 5, // Opcode: LDGT_B
/* 4520 */    MCD::OPC_FilterValue, 241, 1, 9, 0, 0, // Skip to: 4535
/* 4526 */    MCD::OPC_CheckPredicate, 0, 83, 1, 0, // Skip to: 4870
/* 4531 */    MCD::OPC_Decode, 176, 4, 5, // Opcode: LDGT_H
/* 4535 */    MCD::OPC_FilterValue, 242, 1, 9, 0, 0, // Skip to: 4550
/* 4541 */    MCD::OPC_CheckPredicate, 0, 68, 1, 0, // Skip to: 4870
/* 4546 */    MCD::OPC_Decode, 177, 4, 5, // Opcode: LDGT_W
/* 4550 */    MCD::OPC_FilterValue, 243, 1, 9, 0, 0, // Skip to: 4565
/* 4556 */    MCD::OPC_CheckPredicate, 0, 53, 1, 0, // Skip to: 4870
/* 4561 */    MCD::OPC_Decode, 175, 4, 5, // Opcode: LDGT_D
/* 4565 */    MCD::OPC_FilterValue, 244, 1, 9, 0, 0, // Skip to: 4580
/* 4571 */    MCD::OPC_CheckPredicate, 0, 38, 1, 0, // Skip to: 4870
/* 4576 */    MCD::OPC_Decode, 178, 4, 5, // Opcode: LDLE_B
/* 4580 */    MCD::OPC_FilterValue, 245, 1, 9, 0, 0, // Skip to: 4595
/* 4586 */    MCD::OPC_CheckPredicate, 0, 23, 1, 0, // Skip to: 4870
/* 4591 */    MCD::OPC_Decode, 180, 4, 5, // Opcode: LDLE_H
/* 4595 */    MCD::OPC_FilterValue, 246, 1, 9, 0, 0, // Skip to: 4610
/* 4601 */    MCD::OPC_CheckPredicate, 0, 8, 1, 0, // Skip to: 4870
/* 4606 */    MCD::OPC_Decode, 181, 4, 5, // Opcode: LDLE_W
/* 4610 */    MCD::OPC_FilterValue, 247, 1, 9, 0, 0, // Skip to: 4625
/* 4616 */    MCD::OPC_CheckPredicate, 0, 249, 0, 0, // Skip to: 4870
/* 4621 */    MCD::OPC_Decode, 179, 4, 5, // Opcode: LDLE_D
/* 4625 */    MCD::OPC_FilterValue, 248, 1, 9, 0, 0, // Skip to: 4640
/* 4631 */    MCD::OPC_CheckPredicate, 0, 234, 0, 0, // Skip to: 4870
/* 4636 */    MCD::OPC_Decode, 145, 5, 5, // Opcode: STGT_B
/* 4640 */    MCD::OPC_FilterValue, 249, 1, 9, 0, 0, // Skip to: 4655
/* 4646 */    MCD::OPC_CheckPredicate, 0, 219, 0, 0, // Skip to: 4870
/* 4651 */    MCD::OPC_Decode, 147, 5, 5, // Opcode: STGT_H
/* 4655 */    MCD::OPC_FilterValue, 250, 1, 9, 0, 0, // Skip to: 4670
/* 4661 */    MCD::OPC_CheckPredicate, 0, 204, 0, 0, // Skip to: 4870
/* 4666 */    MCD::OPC_Decode, 148, 5, 5, // Opcode: STGT_W
/* 4670 */    MCD::OPC_FilterValue, 251, 1, 9, 0, 0, // Skip to: 4685
/* 4676 */    MCD::OPC_CheckPredicate, 0, 189, 0, 0, // Skip to: 4870
/* 4681 */    MCD::OPC_Decode, 146, 5, 5, // Opcode: STGT_D
/* 4685 */    MCD::OPC_FilterValue, 252, 1, 9, 0, 0, // Skip to: 4700
/* 4691 */    MCD::OPC_CheckPredicate, 0, 174, 0, 0, // Skip to: 4870
/* 4696 */    MCD::OPC_Decode, 149, 5, 5, // Opcode: STLE_B
/* 4700 */    MCD::OPC_FilterValue, 253, 1, 9, 0, 0, // Skip to: 4715
/* 4706 */    MCD::OPC_CheckPredicate, 0, 159, 0, 0, // Skip to: 4870
/* 4711 */    MCD::OPC_Decode, 151, 5, 5, // Opcode: STLE_H
/* 4715 */    MCD::OPC_FilterValue, 254, 1, 9, 0, 0, // Skip to: 4730
/* 4721 */    MCD::OPC_CheckPredicate, 0, 144, 0, 0, // Skip to: 4870
/* 4726 */    MCD::OPC_Decode, 152, 5, 5, // Opcode: STLE_W
/* 4730 */    MCD::OPC_FilterValue, 255, 1, 134, 0, 0, // Skip to: 4870
/* 4736 */    MCD::OPC_CheckPredicate, 0, 129, 0, 0, // Skip to: 4870
/* 4741 */    MCD::OPC_Decode, 150, 5, 5, // Opcode: STLE_D
/* 4745 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 4754
/* 4750 */    MCD::OPC_Decode, 234, 2, 56, // Opcode: BEQZ
/* 4754 */    MCD::OPC_FilterValue, 17, 4, 0, 0, // Skip to: 4763
/* 4759 */    MCD::OPC_Decode, 245, 2, 56, // Opcode: BNEZ
/* 4763 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 4789
/* 4768 */    MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 4771 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4780
/* 4776 */    MCD::OPC_Decode, 231, 2, 57, // Opcode: BCEQZ
/* 4780 */    MCD::OPC_FilterValue, 1, 85, 0, 0, // Skip to: 4870
/* 4785 */    MCD::OPC_Decode, 232, 2, 57, // Opcode: BCNEZ
/* 4789 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 4798
/* 4794 */    MCD::OPC_Decode, 172, 4, 58, // Opcode: JIRL
/* 4798 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 4807
/* 4803 */    MCD::OPC_Decode, 230, 2, 59, // Opcode: B
/* 4807 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 4816
/* 4812 */    MCD::OPC_Decode, 241, 2, 59, // Opcode: BL
/* 4816 */    MCD::OPC_FilterValue, 22, 4, 0, 0, // Skip to: 4825
/* 4821 */    MCD::OPC_Decode, 233, 2, 60, // Opcode: BEQ
/* 4825 */    MCD::OPC_FilterValue, 23, 4, 0, 0, // Skip to: 4834
/* 4830 */    MCD::OPC_Decode, 244, 2, 60, // Opcode: BNE
/* 4834 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 4843
/* 4839 */    MCD::OPC_Decode, 242, 2, 60, // Opcode: BLT
/* 4843 */    MCD::OPC_FilterValue, 25, 4, 0, 0, // Skip to: 4852
/* 4848 */    MCD::OPC_Decode, 235, 2, 60, // Opcode: BGE
/* 4852 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 4861
/* 4857 */    MCD::OPC_Decode, 243, 2, 60, // Opcode: BLTU
/* 4861 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 4870
/* 4866 */    MCD::OPC_Decode, 236, 2, 60, // Opcode: BGEU
/* 4870 */    MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[LoongArch::Feature64Bit]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    if (!Check(S, decodeUImmOperand<2, 1>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 15);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFCSRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFCSRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (!Check(S, decodeSImmOperand<12>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (!Check(S, decodeUImmOperand<12>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (!Check(S, decodeSImmOperand<12>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 38:
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 15, 3);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 16);
    if (!Check(S, decodeSImmOperand<16>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 20);
    if (!Check(S, decodeSImmOperand<20>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 20);
    if (!Check(S, decodeSImmOperand<20>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    if (!Check(S, decodeSImmOperand<14, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 14);
    if (!Check(S, decodeSImmOperand<14, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (!Check(S, decodeSImmOperand<12>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 12);
    if (!Check(S, decodeSImmOperand<12>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 0, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPR64RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 5), 16, 5);
    insertBits(tmp, fieldFromInstruction(insn, 10, 16), 0, 16);
    if (!Check(S, decodeSImmOperand<21, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 5, 3);
    if (!Check(S, DecodeCFRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 5), 16, 5);
    insertBits(tmp, fieldFromInstruction(insn, 10, 16), 0, 16);
    if (!Check(S, decodeSImmOperand<21, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 16);
    if (!Check(S, decodeSImmOperand<16, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 10), 16, 10);
    insertBits(tmp, fieldFromInstruction(insn, 10, 16), 0, 16);
    if (!Check(S, decodeSImmOperand<26, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 5, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 16);
    if (!Check(S, decodeSImmOperand<16, 2>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
